#!/usr/bin/env python

import os
import sys
import warnings
import pandas as pd 
import numpy as np 
import argparse # pour gerer les options
import re # pour les regexp
from pprint import pprint


class recalcCoords (object):

	def __init__(self):
		# initialize mains objects here
		self.parameters = None
		self.annot = {}

		self.stats = { 'num_perfect_anchored' : 0, 
			'num_perfect_multi_anchored' : 0,
			'num_ambigous_match_anchored':0}

		self.version='1.0'
		self.author='Helene Rimbert'

	def main(self):
		"""
		MAIN
		"""
		self.parseOptions()
		self.createWorkingEnv()
		self.loadAnnot(gff=self.parameters.gff)

		pprint(self.stats)

		self.outoutPerfectMatch.close()
		self.outoutPerfectMatchMulti.close()
		self.outoutAmbigousMatch.close()


	def parseOptions(self):
		"""
		Use Argparse to setup/get options from cmd line
		"""
		parser = argparse.ArgumentParser()
		parser.add_argument("-i", "--inputDir", help="Parsed GMAP results directory", required=True)
		parser.add_argument("-g", "--gff", help="Original GFF Annotation", required=True)
		parser.add_argument("-o", "--outputdir", help="output directory", required=True)
		self.parameters=parser.parse_args()

	def createWorkingEnv(self):

		# create output dir
		try:
			os.mkdir(self.parameters.outputdir)
		except OSError:
			print (" Creation of directory  %s failed" % self.parameters.outputdir)
		else:
			print (" Successfully created the directory %s " % self.parameters.outputdir)

		# create filehandler for results
		self.outputGFF = open(self.parameters.outputdir+"/perfectMatches.gff3", "w")
		self.outputPerfectMatchMulti = open(self.parameters.outputdir+"/perfectmatch_multi.gff3", "w")
		self.outputAmbigousMatch = open(self.parameters.outputdir+"/ambigous_match.gff3", "w")

	def loadAnnot(self, gff):
		"""
		loading original GFF annotation
		"""


if __name__ == "__main__":
	"""
	This code block will only be executed if gmapstats.py is called as a script
	(ie. it will not be executed if the gmapstats class is just imported by another module)
	"""
	# build the script object
	engine=recalcCoords()

	# run execute the main method
	engine.main()
